Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Name:           beagle
Version:        0.3.1
Release:        1
Summary:        The Beagle Search Infrastructure
Group:          User Interface/Desktops
License:        LGPL
URL:            http://beagle-project.org/
Source0:        %{name}-%{version}.tar.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  mono-core-devel
BuildRequires:  mono-data mono-data-sqlite
BuildRequires:  gtk-sharp-gapi gtk-sharp-devel gnome-sharp-devel mono-web zip libexif-devel
BuildRequires:  gsf-sharp-devel
BuildRequires:  sqlite-devel
BuildRequires:  gmime-sharp
BuildRequires:  evolution-sharp-devel
BuildRequires:  libXScrnSaver-devel
BuildRequires:  gnome-vfs-devel
BuildRequires:  libgnome-devel
BuildRequires:  gtk2+-devel
BuildRequires:  librsvg-devel
BuildRequires:	PyGTK-devel
BuildRequires:	python-devel
BuildRequires:	libXt-devel
BuildRequires:	gettext
BuildRequires:	autoconf
BuildRequires:	perl-XML-Parser
Requires: 	sqlite
Requires: 	mono-core
Requires: 	zip unzip sed grep poppler-utils

Requires: 	gsf-sharp gtk-sharp gnome-sharp gmime-sharp mono-data

Requires(pre):  shadow

Patch2: beagle-0.2.7-crawl.patch
Patch3: beagle-0.2.1-spew.patch
Patch4: beagle-0.2.7-beagle-index-username.patch
Patch5: beagle-0.3.0-runuser.patch
Patch6: beagle-0.2.15.1-libdir.patch
Patch7: beagle-monodoc.patch

%define grefile /etc/gre.d/gre.conf

%description
A general infrastructure for making your data easy to find. 

%package gui
Summary:      	Beagle search system user interface
Group:        	User Interface/Desktops
Requires:     	beagle = %{version}-%{release}

%description gui
User interface for doing beagle searches

%package evolution
Summary:      	Beagle backend for evolution
Group:        	User Interface/Desktops
Requires:     	beagle = %{version}-%{release}
Requires: 	evolution-sharp

%description evolution
Beagle indexing backend for evolution

%package devel
Summary:    Development files for the Beagle search infrastructure
Group:      Development/Libraries
# for /usr/lib/pkgconfig
Requires:   pkgconfig
# for /usr/lib/monodoc/
Requires:         monodoc
Requires(post):   monodoc
Requires(postun): monodoc

%description devel
The beagle-devel package contains documentation and other materials
that are useful when developing applications that use Beagle.

%prep
%setup -q
%patch2 -p1 -b .crawl
%patch3 -p1 -b .spew
%patch4 -p1 -b .beagleidx
#%patch5 -p1 -b .runuser
%patch6 -p1 -b .libdir
%patch7 -p1 -b .monodoc

%build
autoconf
export MONO_SHARED_DIR=%{_builddir}/%{?buildsubdir}
%configure --enable-wv1
make %{?_smp_mflags}

# Generate the beagle.xpi for mozilla/firefox
pushd .
cd firefox-extension
make
popd

%install
rm -rf $RPM_BUILD_ROOT
export MONO_SHARED_DIR=%{_builddir}/%{?buildsubdir}

make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/var/cache/beagle/indexes


# TODO: Isn't there a better place to install this?
install -m 644 firefox-extension/beagle.xpi $RPM_BUILD_ROOT%{_libdir}/beagle/

echo "NoDisplay=true" >> $RPM_BUILD_ROOT%{_datadir}/applications/beagle-search.desktop

sed -i -e 's@Icon=tango-system-search@Icon=gnome-search-tool@' $RPM_BUILD_ROOT%{_datadir}/applications/beagle-search.desktop

%find_lang %{name}

rm -f $RPM_BUILD_ROOT%{_libdir}/beagle/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/beagle/*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/python*/site-packages/*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/python*/site-packages/*.la

chmod a+x $RPM_BUILD_ROOT%{_libdir}/beagle/*/*.dll
chmod a+x $RPM_BUILD_ROOT%{_libdir}/beagle/*.dll
chmod a+x $RPM_BUILD_ROOT%{_libdir}/beagle/*.exe

#Disable the Thunderbird backend for now (#205985)
rm -f $RPM_BUILD_ROOT%{_libdir}/beagle/Backends/ThunderbirdBackends.dll*

install -m 755 -d $RPM_BUILD_ROOT%_sysconfdir/gnome
mv -f $RPM_BUILD_ROOT%_sysconfdir/xdg $RPM_BUILD_ROOT%_sysconfdir/gnome

# don't autostart the search gui
rm -f $RPM_BUILD_ROOT/etc/gnome/xdg/autostart/beagle-search-autostart.desktop

%pre
%define beagle_user_uid 58
# Remove old username, we switched to an 8 char one
/usr/sbin/groupadd -g %{beagle_user_uid} beaglidx 2> /dev/null || :
/usr/sbin/useradd -u %{beagle_user_uid} -s /sbin/nologin -c "User for Beagle indexing" -d /var/cache/beagle -g beaglidx beaglidx 2> /dev/null || :

%preun
if [ -f %{_libdir}/beagle/beagle-plugin-path ]; then
  old=`cat %{_libdir}/beagle/beagle-plugin-path`
  rm -rf $old
  rm -rf  %{_libdir}/beagle/beagle-plugin-path 
fi

%post 
if [ -f %{_libdir}/beagle/beagle-plugin-path ]; then
  old=`cat %{_libdir}/beagle/beagle-plugin-path`
  rm -rf $old
  rm -rf  %{_libdir}/beagle/beagle-plugin-path 
fi

# install the firefox extension
if [ -f %{grefile} ] ; then
  ffdir=$(cat %{grefile} | awk '/GRE_PATH/ { split($0,p,"="); print p[2] }')

  cd $ffdir/extensions
  mkdir beagle-extension
  unzip -q -d beagle-extension %{_libdir}/beagle/beagle.xpi
  id=`grep em:id beagle-extension/install.rdf | head -1 | sed -e 's/^ *//' -e "s/<[^<]*>//g" | tr -d "\n\r"`
  if [ -e "$id" ]; then
    rm -rf beagle-extension
  else
    mv beagle-extension "$id"
  fi

  echo "$ffdir/extensions/$id" >  %{_libdir}/beagle/beagle-plugin-path
fi

%clean
rm -rf $RPM_BUILD_ROOT

%triggerin -- firefox
if [ -f %{_libdir}/beagle/beagle-plugin-path ]; then
  old=`cat %{_libdir}/beagle/beagle-plugin-path`
  rm -rf $old
  rm -rf  %{_libdir}/beagle/beagle-plugin-path
fi

# install the firefox extension
if [ -f %{grefile} ] ; then
  ffdir=$(cat %{grefile} | awk '/GRE_PATH/ { split($0,p,"="); print p[2] }')

  cd $ffdir/extensions
  mkdir beagle-extension
  unzip -q -d beagle-extension %{_libdir}/beagle/beagle.xpi
  id=`grep em:id beagle-extension/install.rdf | head -1 | sed -e 's/^ *//' -e "s/<[^<]*>//g" | tr -d "\n\r"`
  if [ -e "$id" ]; then
    rm -rf beagle-extension
  else
    mv beagle-extension "$id"
  fi

  echo "$ffdir/extensions/$id" >  %{_libdir}/beagle/beagle-plugin-path
fi

%triggerun -- firefox
# uninstall the firefox extension
if [ $2 = 0 -a -f %{_libdir}/beagle/beagle-plugin-path ]; then
  old=`cat %{_libdir}/beagle/beagle-plugin-path`
  rm -rf $old
  rm -rf  %{_libdir}/beagle/beagle-plugin-path
fi

%files -f %{name}.lang
%defattr(-,root,root,-)
%doc COPYING README
%{_sysconfdir}/cron.daily/*
%{_sysconfdir}/beagle
%{_bindir}/beagle-config
%{_bindir}/beagled
%{_bindir}/beagle-extract-content
%{_bindir}/beagle-index-info
%{_bindir}/beagle-info
%{_bindir}/beagle-ping
%{_bindir}/beagle-query
%{_bindir}/beagle-shutdown
%{_bindir}/beagle-status
#%{_bindir}/beagle-doc-extractor
%{_sbindir}/*
%dir %{_libdir}/beagle
%dir %{_libdir}/beagle/Filters
%dir %{_libdir}/beagle/Backends
%{_libdir}/beagle/BeagleDaemonLib.dll*
%{_libdir}/beagle/BeagleDaemonPlugins.dll*
%{_libdir}/beagle/Beagle.dll*
%{_libdir}/beagle/Util.dll*
%{_libdir}/beagle/BeagleDaemon.exe*
%{_libdir}/beagle/BuildIndex.exe*
%{_libdir}/beagle/DumpIndex.exe*
%{_libdir}/beagle/Config.exe*
%{_libdir}/beagle/ExtractContent.exe*
%{_libdir}/beagle/IndexHelper.exe*
%{_libdir}/beagle/Info.exe*
%{_libdir}/beagle/ManageIndex.exe*
%{_libdir}/beagle/Query.exe*
%{_libdir}/beagle/Shutdown.exe*
%{_libdir}/beagle/beagled-index-helper
%{_libdir}/beagle/libbeagleglue*
%{_libdir}/beagle/Filters/*
#%{_libdir}/beagle/DocExtractor.exe*
#Disabled for now (#205985)
#%{_libdir}/beagle/Backends/ThunderbirdBackends.dll*
# firefox plugin:
%{_libdir}/beagle/beagle.xpi
%{_datadir}/beagle
#%{_datadir}/pixmaps/*
%{_mandir}/*/*
%dir %attr(-,beaglidx,beaglidx) /var/cache/beagle
%dir %attr(-,beaglidx,beaglidx) /var/cache/beagle/indexes
%{_sysconfdir}/gnome/xdg/autostart/beagled-autostart.desktop

%files gui
%defattr(-, root, root)
%{_bindir}/beagle-imlogviewer
%{_bindir}/beagle-search
%{_bindir}/beagle-settings
#%{_libdir}/beagle/Images.dll*
%{_libdir}/beagle/UiUtil.dll*
%{_libdir}/beagle/ImLogViewer.exe*
%{_libdir}/beagle/Search.exe*
%{_libdir}/beagle/Settings.exe*
%{_libdir}/beagle/libbeagleuiglue*
%{_datadir}/applications/*

%files evolution
%defattr(-, root, root)
%{_libdir}/beagle/Backends/EvolutionBackends.dll*

%files devel
%defattr(-, root, root)
%{_libdir}/monodoc/sources/beagle-docs.source
%{_libdir}/monodoc/sources/beagle-docs.tree
%{_libdir}/monodoc/sources/beagle-docs.zip
%{_libdir}/pkgconfig/beagle*.pc

%changelog
* Tue Dec 11 2007 Christian Metzen <metzench@ccux-linux.de> 0.3.1-1
- Version update
* Mon Dec 03 2007 Christian Metzen <metzench@ccux-linux.de> 0.3.0-1
- Version update
* Tue Oct 09 2007 Karsten Brockmann <arcam@ccux-linux.de> 0.2.18-2
- refined Requires list
* Mon Oct 08 2007 Christian Metzen <metzench@ccux-linux.de> 0.2.18-1
- Version update
* Tue Apr 03 2007 Christian Metzen <metzench@ccux-linux.de> 0.2.16.2-2
- fix in user/group addition
* Tue Apr 03 2007 Christian Metzen <metzench@ccux-linux.de> 0.2.16.2-1
- Initial release 
